﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight;
using System.Threading;
using System.Collections.ObjectModel;
using C1.Silverlight.Theming;

namespace SL_C1Window_ProgressBar_CS
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            Application.Current.Resources.MergedDictionaries.Add(C1Theme.GetCurrentThemeResources(new C1.Silverlight.Theming.RainierOrange.C1ThemeRainierOrange()));
        }
        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            var w = new C1Window();
            w.Header = "ComponentOne DataGrid Loading in Background...";
            StackPanel MyStackPanel = new StackPanel();
            TextBlock MyPercentProgress = new TextBlock();
            ProgressBar pb = new ProgressBar();
            pb.Width = 200;
            pb.Height = 40;
            pb.Maximum = 100;
            pb.Minimum = 0;
            MyStackPanel.Children.Add(MyPercentProgress);
            MyStackPanel.Children.Add(pb);
            w.Content = MyStackPanel;
            w.Width = 400;
            w.Height = 120;
            w.CenterOnScreen();
            w.ShowModal();

            Thread t1 = new Thread(new ThreadStart(() =>
            {
                ObservableCollection<Item> items = new ObservableCollection<Item>();
                for (int i = 1; i <= 100; i++)
                {
                    items.Add(new Item(i.ToString()));
                    int counter = i;
                    this.Dispatcher.BeginInvoke(new Action(() =>
                    {
                        string myString = counter.ToString();
                        MyPercentProgress.Text = myString + "% Data Loaded";
                        pb.Value = counter;
                        if (counter == 100)
                        {
                            w.Close();
                            c1DataGrid1.ItemsSource = items;
                        }
                    }));
                    Thread.Sleep(50);
                }
            }));
            t1.Start();
        }
    }
}
public class Item
{
    public Item(string text__1)
    {
        Text = text__1;
    }
    public string Text
    {
        get { return m_Text; }
        set { m_Text = value; }
    }
    private string m_Text;
}
